#include "m_adc.h"

uint8_t adc_sample;

void ADC_IRQHandler(void)
{
    nrf_adc_conversion_event_clean();
    adc_sample = nrf_adc_result_get();
}

void m_adc_config(void)//Configures and enables the ADC
{	
	/* Enable interrupt on ADC sample ready event*/		
	NRF_ADC->INTENSET = ADC_INTENSET_END_Msk;
	NVIC_SetPriority(ADC_IRQn, NRF_APP_PRIORITY_HIGH);
	NVIC_EnableIRQ(ADC_IRQn);
	
	/* Configure ADC - set reference input source to internal 1.2V bandgap */
	NRF_ADC->CONFIG = (ADC_CONFIG_REFSEL_VBG << ADC_CONFIG_REFSEL_Pos);
	/* Configure ADC - set input source to VDD/3 */
	NRF_ADC->CONFIG |= (ADC_CONFIG_INPSEL_SupplyOneThirdPrescaling << ADC_CONFIG_INPSEL_Pos);
	/* Configure ADC - select 8 bit resolution */
	NRF_ADC->CONFIG |= (ADC_CONFIG_RES_8bit << ADC_CONFIG_RES_Pos);
	
	/* Enable ADC*/
	NRF_ADC->ENABLE = ADC_ENABLE_ENABLE_Enabled;
}

