#include "m_csc.h"

void csc_parameter_update(m_flash_t* m_flash, m_csc_t* m_csc)
{
	m_csc->ble_speed_revolution_cnt = m_flash->parameter[0];
	m_csc->ant_speed_revolution_cnt = m_flash->parameter[1];
	m_csc->speed_event_time         = m_flash->parameter[2];
	m_csc->cadence_revolution_cnt   = m_flash->parameter[3];
	m_csc->cadence_event_time       = m_flash->parameter[4];
	m_csc->ant_op_time              = m_flash->parameter[5];
}

void csc_parameter_store(m_flash_t* m_flash, m_csc_t* m_csc)
{
	m_flash->parameter[0] = m_csc->ble_speed_revolution_cnt;
	m_flash->parameter[1] = m_csc->ant_speed_revolution_cnt;
	m_flash->parameter[2] = m_csc->speed_event_time;
	m_flash->parameter[3] = m_csc->cadence_revolution_cnt;
	m_flash->parameter[4] = m_csc->cadence_event_time;
	m_flash->parameter[5] = m_csc->ant_op_time;
}

void count_sleep_time (m_count_t* m_cnt)
{
	if( m_cnt->sleep_cnt < SLEEP_TIME ){
		  m_cnt->sleep_cnt++;
	}else{
		  m_cnt->sleep_cnt=0;
		  sleep_mode_enter();
	}
}

void clear_sleep_time (m_count_t* m_cnt)
{
	m_cnt->sleep_cnt=0;
}

void count_stop_time (m_count_t* m_cnt)
{
	if( m_cnt->stop_cnt < STOP_TIME ){
		  m_cnt->stop_cnt++;
	}else{
		  m_cnt->stop_cnt =0;
		  m_cnt->stop_flag=0;
	}
}

void clear_stop_time (m_count_t* m_cnt)
{
	m_cnt->stop_cnt =0;
}

