
#ifndef M_CSC_H__
#define M_CSC_H__

#include <stdint.h>
#include <stdio.h>
#include <string.h>

#include "nrf_log.h"
#include "nrf_delay.h"


#define SLEEP_TIME  120 //900 //unit: sec = 15mins
#define STOP_TIME   4   //uint: sec
									
typedef struct {
  uint32_t parameter[6];
	/*
	parameter[0]: ble_speed_revolution_cnt;
  parameter[1]: ant_speed_revolution_cnt;
  parameter[2]: speed_event_time;
  parameter[3]: cadence_revolution_cnt;
  parameter[4]: cadence_event_time;
	parameter[5]: Ant OP Time
	*/
}m_flash_t;

typedef struct {
  
  uint32_t ble_speed_revolution_cnt;
  uint16_t ant_speed_revolution_cnt;
  uint16_t speed_event_time;
	uint32_t ble_speed_revolution_cnt_tmp;
  uint16_t speed_event_time_tmp;
  uint16_t speed_event_time_update;
	
  uint16_t cadence_revolution_cnt;
  uint16_t cadence_event_time;
  uint16_t cadence_revolution_cnt_tmp;
  uint16_t cadence_event_time_tmp;
  uint16_t cadence_event_time_update;
	
	uint32_t ant_op_time;
}m_csc_t;

typedef struct {
  uint16_t sleep_cnt;
  uint16_t stop_cnt;
	uint8_t  stop_flag;
  
}m_count_t;


extern void sleep_mode_enter(void);
void csc_parameter_update(m_flash_t* m_flash, m_csc_t* m_csc);
void csc_parameter_store (m_flash_t* m_flash, m_csc_t* m_csc);

void count_sleep_time (m_count_t* m_cnt);
void clear_sleep_time (m_count_t* m_cnt);
void count_stop_time  (m_count_t* m_cnt);
void clear_stop_time  (m_count_t* m_cnt);

#endif
