#include "m_led.h"


static low_power_pwm_t low_power_pwm_0;

void pwm_handler(void * p_context)
{
    static uint16_t led_0;
    uint32_t err_code;
    UNUSED_PARAMETER(p_context);
    
    low_power_pwm_t * pwm_instance = (low_power_pwm_t*)p_context;
    
    if(pwm_instance->bit_mask == M_LED_MASK)
    {
        led_0++;
        if(led_0 < TICKS_BEFORE_CHANGE_0)
				{
					 err_code = low_power_pwm_duty_set(pwm_instance, 0);
           APP_ERROR_CHECK(err_code);
				}
				else
        {
           if( led_0 > (TICKS_BEFORE_CHANGE_0+50) ){
               led_0 = 0;
						}
           err_code = low_power_pwm_duty_set(pwm_instance, 20);
           APP_ERROR_CHECK(err_code);
        }
    }
}

void low_power_init(void)
{
    uint32_t err_code;
    low_power_pwm_config_t low_power_pwm_config;
	
    APP_TIMER_DEF(lpp_timer_0);
    low_power_pwm_config.active_high = false;
    low_power_pwm_config.period      = 100;
    low_power_pwm_config.bit_mask    = M_LED_MASK;
    low_power_pwm_config.p_timer_id  = &lpp_timer_0;
    
    err_code = low_power_pwm_init((&low_power_pwm_0), &low_power_pwm_config, pwm_handler);
    APP_ERROR_CHECK(err_code);
	
    err_code = low_power_pwm_duty_set(&low_power_pwm_0, 0);
    APP_ERROR_CHECK(err_code);

    err_code = low_power_pwm_start((&low_power_pwm_0), low_power_pwm_0.bit_mask);
    APP_ERROR_CHECK(err_code);
}

void low_power_stop (void)
{
	uint32_t err_code;
	
	err_code = low_power_pwm_duty_set(&low_power_pwm_0, 100);
  APP_ERROR_CHECK(err_code);
	
	err_code = low_power_pwm_stop(&low_power_pwm_0);
	APP_ERROR_CHECK(err_code);
}
